import java.util.*;

/**
 * Lab #3
 * CS 2334, Section 0??
 * September 18, 2008
 * <P>
 * This class implements a program that tests the Word class code.
 * </P>
 * @author Group #?
 * @version 1.0
 */
public class Driver 
{
	/**
	 * This is the main method for this driver program. Since this is a
	 * simple program, all of our code will be in the main method.
	 * Typically this would be a bad design, but we are just testing out
	 * some features of Java.
	 * <P>
	 * Algorithm<br>
	 * 1. Instantiate eight objects of type Word and add 
	 *    them to the list 'words'.
	 * 2. Print out the unsorted list of words.
	 * 3. Sort the list of words using Collections.sort().
	 * 4. Print out the sorted list of words.
	 * 5. Search for a particular word in the list.
	 * 6. Test your compareTo method.
	 * </P>
	 * @param             args       Contains the command line arguments.
	 */
	@SuppressWarnings("unchecked")
	public static void main(String[] args) 
	{
		List words = new ArrayList();

		/* 
		 * 1. Instantiate eight objects of type word and add them
		 *    to the list words. 
		 * I have created and added the first word for you. :)
		 */        
		Word w1 = new Word( "carnivoro", "Spanish" );

		/* The list is referenced to by the variable words.  You can add to
		 * the list by invoking the add method in ArrayList.
		 */
		words.add( w1 );


		/*
		 * 2. Print out the unsorted list of words.
		 * This uses an iterator to "iterate" through the list.
		 */
		System.out.println( "\n\nUnsorted List:" );

		Iterator iterator = words.iterator();

		while( iterator.hasNext() )
		{
			// Note: This line of code will call toString of the Word class.
			System.out.println( iterator.next() );
		}


		/*
		 * 3. Sort the list of words  using Collections.sort().
		 * Take a look at Collections.sort() in the API at
		 * http://java.sun.com/j2se/1.5.0/docs/api/java/util/Collections.html#sort(java.util.List,%20java.util.Comparator)
		 * You need to call Collections.sort() and pass it the list of words.
		 * SEE THE LAB HANDOUT FOR MORE INFORMATION.
		 */

		// ADD CODE TO SORT HERE


		/*
		 * 4. Print out the sorted list of words.
		 */
		System.out.println( "Sorted List:" );
		/* HINT: Use an iterator the same way I used one above when
		 * the unsorted list of words was printed.
		 */

		// ADD CODE TO PRINT THE LIST HERE     


		/* 
		 * 5. Search for a particular word in the list.
		 */
		System.out.println( "\n\nSearching" );
		Word key = new Word( "carnivore", "Spanish" );
		System.out.println( "Key is " + key );

		/*
		 * Call Collections.binarySearch() to find the index of key.  
		 * Make sure you test the value of index to see if it negative, 
		 * which indicates that the key was not found in the list.
		 */
		int index = Collections.binarySearch( words, key );

		/* 
		 * Print out whether the word was found or not and the index
		 * at which it was found.
		 * HINT: If index is negative print a statement saying that the
		 *       item searched for is not in the list.  Otherwise, print
		 *       out a statement telling that item was found in the list
		 *       and give the index of item in the list as well.
		 */

		// ADD CODE HERE


	}
}
